from random import randint, seed, shuffle
seed(47)

def shuffled(seq):
    shuffle(seq)
    return seq

def do_star(n):
    return shuffled( [n-1] + (n-1)*[1] )

def do_two_equal(n):
    assert n%2 == 0 and n >= 4
    d = n // 2
    return shuffled( 2*[d] + (n-2)*[1] )

def do_two_unequal(n):
    assert n >= 5
    while True:
        d1 = randint(2,n-2)
        d2 = n - d1
        if d1 != d2: break
    return shuffled( [d1,d2] + (n-2)*[1] )

def do_three_equal(n):
    assert (n+1) % 3 == 0
    d = (n+1) // 3
    assert d >= 2
    return shuffled( 3*[d] + (n-3)*[1] )

def do_three_bbs(n,rotate):
    assert n >= 7
    while True:
        d1 = randint(2,n-1)
        d2 = n+1-2*d1
        if d1 > d2 >= 2: break
    bigs = [d1,d1,d2]
    bigs = bigs[rotate:] + bigs[:rotate]
    ans = shuffled( 3*[None] + (n-3)*[1] )
    for i in range(n):
        if ans[i] is None:
            ans[i] = bigs.pop()
    return ans

def do_three_bss(n,rotate):
    assert n >= 6
    while True:
        d1 = randint(2,n-1)
        d2 = n+1-2*d1
        if d2 > d1: break
    bigs = [d1,d1,d2]
    bigs = bigs[rotate:] + bigs[:rotate]
    ans = shuffled( 3*[None] + (n-3)*[1] )
    for i in range(n):
        if ans[i] is None:
            ans[i] = bigs.pop()
    return ans

def all_threes():
    answer = []
    for r in range(3):
        answer.append( lambda n: do_three_bbs(n,r) )
        answer.append( lambda n: do_three_bss(n,r) )
    return answer

def do_path(n):
    assert n >= 2
    return (n-2)*[2] + 2*[1]

def do_four_equal(n):
    assert (n+2)%4 == 0 and n >= 10
    d = (n+2) // 4
    return shuffled( 4*[d] + (n-4)*[1] )

def do_many_threes(n):
    # x*3 potrebuje este x+2 listov
    assert n%4 == 2 and n >= 14
    return shuffled( (n//4)*[3] + (n//4 + 2)*[1] )

def do_more_equal(n):
    c = randint(5,7)
    assert (n+c-2)%c == 0 and (n+c-2)//c >= 3
    d = (n+c-2)//c
    return shuffled( c*[d] + (n-c)*[1] )

def do_random_tree(n):
    assert n >= 6
    answer = n*[1]
    for i in range(n-2): answer[ randint(0,n-1) ] += 1
    return answer

def do_random_2n(n):
    assert n >= 6
    answer = n*[1]
    for i in range(n): answer[ randint(0,n-1) ] += 1
    return answer

def do_minimal(n):
    return n*[1]

def do_maximal(n):
    return n*[n-1]

def do_random(n):
    while True:
        seq = [ randint(1,n-1) for _ in range(n) ]
        if sum(seq) != 2*n-2: return seq

def savef(f,T,test):
    print(T, file=f)
    print(len(test), file=f)
    print(*test, file=f)
    f.close()

def save(tid,sid,T,test):
    f = open('{:02d}.{:02d}.in'.format(tid,sid), 'w')
    savef(f,T,test)

one_functions = [ do_star, do_two_equal, do_two_unequal, do_three_equal, do_path, do_random_2n, do_minimal, do_maximal, do_random ]
all_functions = one_functions + [ do_four_equal, do_more_equal, do_many_threes, do_random_tree, do_random_tree ] + all_threes()

MINN = [ 3, 11, 1000, 9*10**4, 9*10**5 ]
MAXN = [ 5, 100, 5000, 10**5, 10**6 ]

tid = 0

for T in [1,2]:
    for sub in range(5):
        tid += 1
        minn, maxn = MINN[sub], MAXN[sub]
        TESTS = []
        if sub in [1,3]:
            functions = one_functions
        else:
            functions = all_functions
        for f in functions:
            print(f.__name__)
            for tries in range(1000):
                try:
                    n = randint(minn,maxn)
                    TESTS.append( f(n) )
                    break
                except:
                    pass
        if sub == 0:
            TESTS.append( do_star(2) )
        for sid, test in enumerate(TESTS):
            save(tid,sid+1,T,test)

savef(open('00.sample.1.in','w'), 2, [1,1,1,1])
savef(open('00.sample.2.in','w'), 2, [1,3,1,1,3,1])
savef(open('00.sample.3.in','w'), 1, [1,3,1,1,3,1])
savef(open('00.sample.4.in','w'), 2, [4,3,2,1,1,1,1,1])

